/*
 *   This file is a part of the SteamWar software.
 *
 *   Copyright (C) 2025 SteamWar.de-Serverteam
 *
 *   This program is free software: you can redistribute it and/or modify
 *   it under the terms of the GNU Affero General Public License as published by
 *   the Free Software Foundation, either version 3 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 *   GNU Affero General Public License for more details.
 *
 *   You should have received a copy of the GNU Affero General Public License
 *   along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */

package de.steamwar.bausystem.commands;

import de.steamwar.bausystem.BauSystem;
import de.steamwar.command.SWCommand;
import de.steamwar.sql.*;
import org.bukkit.entity.Player;

public class CommandLockschem extends SWCommand {

    public CommandLockschem() {
        super("lockschem");
    }

    @Register(help = true)
    public void genericHelp(Player p, String... args) {
        if (!SteamwarUser.get(p.getUniqueId()).hasPerm(UserPerm.CHECK)) {
            return;
        }

        sendHelp(p);
    }

    @Register
    public void genericCommand(Player p, String owner, String schematicName) {
        if (!SteamwarUser.get(p.getUniqueId()).hasPerm(UserPerm.CHECK)) {
            return;
        }

        SteamwarUser schemOwner = SteamwarUser.get(owner);
        if (schemOwner == null) {
            p.sendMessage(BauSystem.PREFIX + "Dieser Spieler existiert nicht!");
            return;
        }
        SchematicNode node = SchematicNode.getNodeFromPath(schemOwner, schematicName);
        if (node == null) {
            p.sendMessage(BauSystem.PREFIX + "Dieser Spieler besitzt keine Schematic mit diesem Namen!");
            return;
        }
        p.sendMessage(BauSystem.PREFIX + "Schematic " + node .getName() + " von " +
                SteamwarUser.get(node.getOwner()).getUserName() + " von " + node.getSchemtype().toString() +
                " auf NORMAL zurückgesetzt!");
        node.setSchemtype(SchematicType.Normal);
    }

    private void sendHelp(Player player) {
        player.sendMessage("§8/§eschemlock §8[§7Owner§8] §8[§7Schematic§8] §8- §7 Sperre eine Schematic");
    }
}
